Package org.springframework.jmx.export

# Class MBeanExporter

java.lang.Object
org.springframework.jmx.support.MBeanRegistrationSupport
org.springframework.jmx.export.MBeanExporter

All Implemented Interfaces:
  `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanClassLoaderAware`, `org.springframework.beans.factory.BeanFactoryAware`, `org.springframework.beans.factory.DisposableBean`, `org.springframework.beans.factory.InitializingBean`, `org.springframework.beans.factory.SmartInitializingSingleton`, `MBeanExportOperations`

Direct Known Subclasses:
  `AnnotationMBeanExporter`

public class MBeanExporter extends MBeanRegistrationSupport implements MBeanExportOperations, org.springframework.beans.factory.BeanClassLoaderAware, org.springframework.beans.factory.BeanFactoryAware, org.springframework.beans.factory.InitializingBean, org.springframework.beans.factory.SmartInitializingSingleton, org.springframework.beans.factory.DisposableBean
JMX exporter that allows for exposing any Spring-managed bean to a JMX `MBeanServer`, without the need to define any JMX-specific information in the bean classes.

If a bean implements one of the JMX management interfaces, MBeanExporter can simply register the MBean with the server through its auto-detection process.

If a bean does not implement one of the JMX management interfaces, MBeanExporter will create the management information using the supplied `MBeanInfoAssembler`.

A list of `MBeanExporterListeners` can be registered via the `listeners` property, allowing application code to be notified of MBean registration and unregistration events.

This exporter is compatible with MBeans as well as MXBeans.

Since:
  1.2
Author:
  Rob Harrop, Juergen Hoeller, Rick Evans, Mark Fisher, Stephane Nicoll, Sam Brannen
See Also:
  - `setBeans(java.util.Map<java.lang.String, java.lang.Object>)`
  - `setAutodetect(boolean)`
  - `setAssembler(org.springframework.jmx.export.assembler.MBeanInfoAssembler)`
  - `setListeners(org.springframework.jmx.export.MBeanExporterListener...)`
  - `MBeanInfoAssembler`
  - `MBeanExporterListener`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`AUTODETECT_ALL`
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
`static final int`
`AUTODETECT_ASSEMBLER`
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
`static final int`
`AUTODETECT_MBEAN`
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
`static final int`
`AUTODETECT_NONE`
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`

### Fields inherited from class org.springframework.jmx.support.MBeanRegistrationSupport

`logger, server`

## Constructor Summary

Constructors
Constructor
Description
`MBeanExporter()`

## Method Summary

Modifier and Type
Method
Description
`protected DynamicMBean`
`adaptMBeanIfPossible(Object bean)`
Build an adapted MBean for the given bean instance, if possible.
`void`
`addExcludedBean(String excludedBean)`
Add the name of bean that should be excluded from auto-detection.
`void`
`afterPropertiesSet()`
`void`
`afterSingletonsInstantiated()`
Kick off bean registration automatically after the regular singleton instantiation phase.
`protected ModelMBean`
`createAndConfigureMBean(Object managedResource, String beanKey)`
Creates an MBean that is configured with the appropriate management interface for the supplied managed resource.
`protected ModelMBean`
`createModelMBean()`
Create an instance of a class that implements `ModelMBean`.
`void`
`destroy()`
Unregisters all beans that this exported has exposed via JMX when the enclosing `ApplicationContext` is destroyed.
`protected ObjectName`
`getObjectName(Object bean, String beanKey)`
Retrieve the `ObjectName` for a bean.
`protected boolean`
`isBeanDefinitionLazyInit(org.springframework.beans.factory.ListableBeanFactory beanFactory, String beanName)`
Return whether the specified bean definition should be considered as lazy-init.
`protected boolean`
`isMBean(Class<?> beanClass)`
Determine whether the given bean class qualifies as an MBean as-is.
`protected void`
`onRegister(ObjectName objectName)`
Called when an MBean is registered.
`protected void`
`onUnregister(ObjectName objectName)`
Called when an MBean is unregistered.
`protected ObjectName`
`registerBeanNameOrInstance(Object mapValue, String beanKey)`
Register an individual bean with the `MBeanServer`.
`protected void`
`registerBeans()`
Register the defined beans with the `MBeanServer`.
`ObjectName`
`registerManagedResource(Object managedResource)`
Register the supplied resource with JMX.
`void`
`registerManagedResource(Object managedResource, ObjectName objectName)`
Register the supplied resource with JMX.
`void`
`setAllowEagerInit(boolean allowEagerInit)`
Specify whether to allow eager initialization of candidate beans when auto-detecting MBeans in the Spring application context.
`void`
`setAssembler(MBeanInfoAssembler assembler)`
Set the implementation of the `MBeanInfoAssembler` interface to use for this exporter.
`void`
`setAutodetect(boolean autodetect)`
Set whether to autodetect MBeans in the bean factory that this exporter runs in.
`void`
`setAutodetectMode(int autodetectMode)`
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
`void`
`setAutodetectModeName(String constantName)`
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
`void`
`setBeanClassLoader(ClassLoader classLoader)`
`void`
`setBeanFactory(org.springframework.beans.factory.BeanFactory beanFactory)`
This callback is only required for resolution of bean names in the `"beans"` `Map` and for auto-detection of MBeans (in the latter case, a `ListableBeanFactory` is required).
`void`
`setBeans(Map<String,Object> beans)`
Supply a `Map` of beans to be registered with the JMX `MBeanServer`.
`void`
`setEnsureUniqueRuntimeObjectNames(boolean ensureUniqueRuntimeObjectNames)`
Indicates whether Spring should ensure that `ObjectNames` generated by the configured `ObjectNamingStrategy` for runtime-registered MBeans (`registerManagedResource(java.lang.Object)`) should get modified: to ensure uniqueness for every instance of a managed `Class`.
`void`
`setExcludedBeans(String... excludedBeans)`
Set the list of names for beans that should be excluded from auto-detection.
`void`
`setExposeManagedResourceClassLoader(boolean exposeManagedResourceClassLoader)`
Indicates whether the managed resource should be exposed on the `thread context ClassLoader` before allowing any invocations on the MBean to occur.
`void`
`setListeners(MBeanExporterListener... listeners)`
Set the `MBeanExporterListener`s that should be notified of MBean registration and unregistration events.
`void`
`setNamingStrategy(ObjectNamingStrategy namingStrategy)`
Set the implementation of the `ObjectNamingStrategy` interface to use for this exporter.
`void`
`setNotificationListenerMappings(Map<?,? extends NotificationListener> listeners)`
Set the `NotificationListeners` to register with the `MBeanServer`.
`void`
`setNotificationListeners(NotificationListenerBean... notificationListeners)`
Set the `NotificationListenerBeans` containing the `NotificationListeners` that will be registered with the `MBeanServer`.
`void`
`unregisterManagedResource(ObjectName objectName)`
Remove the specified MBean from the underlying MBeanServer registry.

### Methods inherited from class org.springframework.jmx.support.MBeanRegistrationSupport

`doRegister, doUnregister, getRegisteredObjectNames, getServer, onRegister, setRegistrationPolicy, setServer, unregisterBeans`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### AUTODETECT_NONE

@Deprecated(since="6.1") public static final int AUTODETECT_NONE
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
Auto-detection mode indicating that no auto-detection should be used.

See Also:
  - Constant Field Values

### AUTODETECT_MBEAN

@Deprecated(since="6.1") public static final int AUTODETECT_MBEAN
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
Auto-detection mode indicating that only valid MBeans should be autodetected.

See Also:
  - Constant Field Values

### AUTODETECT_ASSEMBLER

@Deprecated(since="6.1") public static final int AUTODETECT_ASSEMBLER
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
Auto-detection mode indicating that only the `MBeanInfoAssembler` should be able to autodetect beans.

See Also:
  - Constant Field Values

### AUTODETECT_ALL

@Deprecated(since="6.1") public static final int AUTODETECT_ALL
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
Auto-detection mode indicating that all auto-detection mechanisms should be used.

See Also:
  - Constant Field Values

## Constructor Details

### MBeanExporter

public MBeanExporter()

## Method Details

### setBeans

public void setBeans(Map<String,Object> beans)
Supply a `Map` of beans to be registered with the JMX `MBeanServer`.

The String keys are the basis for the creation of JMX object names. By default, a JMX `ObjectName` will be created straight from the given key. This can be customized through specifying a custom `NamingStrategy`.

Both bean instances and bean names are allowed as values. Bean instances are typically linked in through bean references. Bean names will be resolved as beans in the current factory, respecting lazy-init markers (that is, not triggering initialization of such beans).

Parameters:
  `beans` - a Map with JMX names as keys and bean instances or bean names as values
See Also:
  - `setNamingStrategy(org.springframework.jmx.export.naming.ObjectNamingStrategy)`
  - `KeyNamingStrategy`
  - `ObjectName(String)`

### setAutodetect

public void setAutodetect(boolean autodetect)
Set whether to autodetect MBeans in the bean factory that this exporter runs in. Will also ask an `AutodetectCapableMBeanInfoAssembler` if available.

This feature is turned off by default. Explicitly specify `true` here to enable auto-detection.

See Also:
  - `setAssembler(org.springframework.jmx.export.assembler.MBeanInfoAssembler)`
  - `AutodetectCapableMBeanInfoAssembler`
  - `isMBean(java.lang.Class<?>)`

### setAutodetectModeName

@Deprecated(since="6.1") public void setAutodetectModeName(String constantName)
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
Set the auto-detection mode to use by name.

Throws:
  `IllegalArgumentException` - if the supplied value is not resolvable to one of the `AUTODETECT_` constants or is `null`
See Also:
  - `setAutodetectMode(int)`
  - `AUTODETECT_ALL`
  - `AUTODETECT_ASSEMBLER`
  - `AUTODETECT_MBEAN`
  - `AUTODETECT_NONE`

### setAutodetectMode

@Deprecated(since="6.1") public void setAutodetectMode(int autodetectMode)
Deprecated.
as of 6.1, in favor of the `"autodetect" flag`
Set the auto-detection mode to use.

Throws:
  `IllegalArgumentException` - if the supplied value is not one of the `AUTODETECT_` constants
See Also:
  - `setAutodetectModeName(String)`
  - `AUTODETECT_ALL`
  - `AUTODETECT_ASSEMBLER`
  - `AUTODETECT_MBEAN`
  - `AUTODETECT_NONE`

### setAllowEagerInit

public void setAllowEagerInit(boolean allowEagerInit)
Specify whether to allow eager initialization of candidate beans when auto-detecting MBeans in the Spring application context.

Default is "false", respecting lazy-init flags on bean definitions. Switch this to "true" in order to search lazy-init beans as well, including FactoryBean-produced objects that haven't been initialized yet.

### setAssembler

public void setAssembler(MBeanInfoAssembler assembler)
Set the implementation of the `MBeanInfoAssembler` interface to use for this exporter. Default is a `SimpleReflectiveMBeanInfoAssembler`.

The passed-in assembler can optionally implement the `AutodetectCapableMBeanInfoAssembler` interface, which enables it to participate in the exporter's MBean auto-detection process.

See Also:
  - `SimpleReflectiveMBeanInfoAssembler`
  - `AutodetectCapableMBeanInfoAssembler`
  - `MetadataMBeanInfoAssembler`
  - `setAutodetect(boolean)`

### setNamingStrategy

public void setNamingStrategy(ObjectNamingStrategy namingStrategy)
Set the implementation of the `ObjectNamingStrategy` interface to use for this exporter. Default is a `KeyNamingStrategy`.

See Also:
  - `KeyNamingStrategy`
  - `MetadataNamingStrategy`

### setEnsureUniqueRuntimeObjectNames

public void setEnsureUniqueRuntimeObjectNames(boolean ensureUniqueRuntimeObjectNames)
Indicates whether Spring should ensure that `ObjectNames` generated by the configured `ObjectNamingStrategy` for runtime-registered MBeans (`registerManagedResource(java.lang.Object)`) should get modified: to ensure uniqueness for every instance of a managed `Class`.

The default value is `true`.

See Also:
  - `registerManagedResource(java.lang.Object)`
  - `JmxUtils.appendIdentityToObjectName(javax.management.ObjectName, Object)`

### setExposeManagedResourceClassLoader

public void setExposeManagedResourceClassLoader(boolean exposeManagedResourceClassLoader)
Indicates whether the managed resource should be exposed on the `thread context ClassLoader` before allowing any invocations on the MBean to occur.

The default value is `true`, exposing a `SpringModelMBean` which performs thread context ClassLoader management. Switch this flag off to expose a standard JMX `RequiredModelMBean`.

### setExcludedBeans

public void setExcludedBeans(String... excludedBeans)
Set the list of names for beans that should be excluded from auto-detection.

### addExcludedBean

public void addExcludedBean(String excludedBean)
Add the name of bean that should be excluded from auto-detection.

### setListeners

public void setListeners(MBeanExporterListener... listeners)
Set the `MBeanExporterListener`s that should be notified of MBean registration and unregistration events.

See Also:
  - `MBeanExporterListener`

### setNotificationListeners

public void setNotificationListeners(NotificationListenerBean... notificationListeners)
Set the `NotificationListenerBeans` containing the `NotificationListeners` that will be registered with the `MBeanServer`.

See Also:
  - `setNotificationListenerMappings(java.util.Map)`
  - `NotificationListenerBean`

### setNotificationListenerMappings

public void setNotificationListenerMappings(Map<?,? extends NotificationListener> listeners)
Set the `NotificationListeners` to register with the `MBeanServer`.

The key of each entry in the `Map` is a `String` representation of the `ObjectName` or the bean name of the MBean the listener should be registered for. Specifying an asterisk (`*`) for a key will cause the listener to be associated with all MBeans registered by this class at startup time.

The value of each entry is the `NotificationListener` to register. For more advanced options such as registering `NotificationFilters` and handback objects see `setNotificationListeners(NotificationListenerBean[])`.

### setBeanClassLoader

public void setBeanClassLoader(ClassLoader classLoader)

Specified by:
  `setBeanClassLoader` in interface `org.springframework.beans.factory.BeanClassLoaderAware`

### setBeanFactory

public void setBeanFactory(org.springframework.beans.factory.BeanFactory beanFactory)
This callback is only required for resolution of bean names in the `"beans"` `Map` and for auto-detection of MBeans (in the latter case, a `ListableBeanFactory` is required).

Specified by:
  `setBeanFactory` in interface `org.springframework.beans.factory.BeanFactoryAware`
See Also:
  - `setBeans(java.util.Map<java.lang.String, java.lang.Object>)`
  - `setAutodetect(boolean)`

### afterPropertiesSet

public void afterPropertiesSet()

Specified by:
  `afterPropertiesSet` in interface `org.springframework.beans.factory.InitializingBean`

### afterSingletonsInstantiated

public void afterSingletonsInstantiated()
Kick off bean registration automatically after the regular singleton instantiation phase.

Specified by:
  `afterSingletonsInstantiated` in interface `org.springframework.beans.factory.SmartInitializingSingleton`
See Also:
  - `registerBeans()`

### destroy

public void destroy()
Unregisters all beans that this exported has exposed via JMX when the enclosing `ApplicationContext` is destroyed.

Specified by:
  `destroy` in interface `org.springframework.beans.factory.DisposableBean`

### registerManagedResource

public ObjectName registerManagedResource(Object managedResource) throws MBeanExportException
Description copied from interface: `MBeanExportOperations`
Register the supplied resource with JMX. If the resource is not a valid MBean already, Spring will generate a management interface for it. The exact interface generated will depend on the implementation and its configuration. This call also generates an `ObjectName` for the managed resource and returns this to the caller.

Specified by:
  `registerManagedResource` in interface `MBeanExportOperations`
Parameters:
  `managedResource` - the resource to expose via JMX
Returns:
  the `ObjectName` under which the resource was exposed
Throws:
  `MBeanExportException` - if Spring is unable to generate an `ObjectName` or register the MBean

### registerManagedResource

public void registerManagedResource(Object managedResource, ObjectName objectName) throws MBeanExportException
Description copied from interface: `MBeanExportOperations`
Register the supplied resource with JMX. If the resource is not a valid MBean already, Spring will generate a management interface for it. The exact interface generated will depend on the implementation and its configuration.

Specified by:
  `registerManagedResource` in interface `MBeanExportOperations`
Parameters:
  `managedResource` - the resource to expose via JMX
  `objectName` - the `ObjectName` under which to expose the resource
Throws:
  `MBeanExportException` - if Spring is unable to register the MBean

### unregisterManagedResource

public void unregisterManagedResource(ObjectName objectName)
Description copied from interface: `MBeanExportOperations`
Remove the specified MBean from the underlying MBeanServer registry.

Specified by:
  `unregisterManagedResource` in interface `MBeanExportOperations`
Parameters:
  `objectName` - the `ObjectName` of the resource to remove

### registerBeans

protected void registerBeans()
Register the defined beans with the `MBeanServer`.

Each bean is exposed to the `MBeanServer` via a `ModelMBean`. The actual implementation of the `ModelMBean` interface used depends on the implementation of the `ModelMBeanProvider` interface that is configured. By default, the `RequiredModelMBean` class that is supplied with all JMX implementations is used.

The management interface produced for each bean is dependent on the `MBeanInfoAssembler` implementation being used. The `ObjectName` given to each bean is dependent on the implementation of the `ObjectNamingStrategy` interface being used.

### isBeanDefinitionLazyInit

protected boolean isBeanDefinitionLazyInit(org.springframework.beans.factory.ListableBeanFactory beanFactory, String beanName)
Return whether the specified bean definition should be considered as lazy-init.

Parameters:
  `beanFactory` - the bean factory that is supposed to contain the bean definition
  `beanName` - the name of the bean to check
See Also:
  - `ConfigurableListableBeanFactory.getBeanDefinition(java.lang.String)`
  - `BeanDefinition.isLazyInit()`

### registerBeanNameOrInstance

protected ObjectName registerBeanNameOrInstance(Object mapValue, String beanKey) throws MBeanExportException
Register an individual bean with the `MBeanServer`.

This method is responsible for deciding how a bean should be exposed to the `MBeanServer`. Specifically, if the supplied `mapValue` is the name of a bean that is configured for lazy initialization, then a proxy to the resource is registered with the `MBeanServer` so that the lazy load behavior is honored. If the bean is already an MBean then it will be registered directly with the `MBeanServer` without any intervention. For all other beans or bean names, the resource itself is registered with the `MBeanServer` directly.

Parameters:
  `mapValue` - the value configured for this bean in the beans map; may be either the `String` name of a bean, or the bean itself
  `beanKey` - the key associated with this bean in the beans map
Returns:
  the `ObjectName` under which the resource was registered
Throws:
  `MBeanExportException` - if the export failed
See Also:
  - `setBeans(java.util.Map<java.lang.String, java.lang.Object>)`
  - `registerBeanInstance(java.lang.Object, java.lang.String)`
  - `registerLazyInit(java.lang.String, java.lang.String)`

### getObjectName

protected ObjectName getObjectName(Object bean, @Nullable String beanKey) throws MalformedObjectNameException
Retrieve the `ObjectName` for a bean.

If the bean implements the `SelfNaming` interface, then the `ObjectName` will be retrieved using `SelfNaming.getObjectName()`. Otherwise, the configured `ObjectNamingStrategy` is used.

Parameters:
  `bean` - the name of the bean in the `BeanFactory`
  `beanKey` - the key associated with the bean in the beans map
Returns:
  the `ObjectName` for the supplied bean
Throws:
  `MalformedObjectNameException` - if the retrieved `ObjectName` is malformed

### isMBean

protected boolean isMBean(@Nullable Class<?> beanClass)
Determine whether the given bean class qualifies as an MBean as-is.

The default implementation delegates to `JmxUtils.isMBean(java.lang.Class<?>)`, which checks for `DynamicMBean` classes as well as classes with corresponding "*MBean" interface (Standard MBeans) or corresponding "*MXBean" interface (Java MXBeans).

Parameters:
  `beanClass` - the bean class to analyze
Returns:
  whether the class qualifies as an MBean
See Also:
  - `JmxUtils.isMBean(Class)`

### adaptMBeanIfPossible

@Nullable protected DynamicMBean adaptMBeanIfPossible(Object bean) throws JMException
Build an adapted MBean for the given bean instance, if possible.

The default implementation builds a JMX 1.2 StandardMBean for the target's MBean/MXBean interface in case of an AOP proxy, delegating the interface's management operations to the proxy.

Parameters:
  `bean` - the original bean instance
Returns:
  the adapted MBean, or `null` if not possible
Throws:
  `JMException`

### createAndConfigureMBean

protected ModelMBean createAndConfigureMBean(Object managedResource, String beanKey) throws MBeanExportException
Creates an MBean that is configured with the appropriate management interface for the supplied managed resource.

Parameters:
  `managedResource` - the resource that is to be exported as an MBean
  `beanKey` - the key associated with the managed bean
Throws:
  `MBeanExportException`
See Also:
  - `createModelMBean()`
  - `getMBeanInfo(Object, String)`

### createModelMBean

protected ModelMBean createModelMBean() throws MBeanException
Create an instance of a class that implements `ModelMBean`.

This method is called to obtain a `ModelMBean` instance to use when registering a bean. This method is called once per bean during the registration phase and must return a new instance of `ModelMBean`

Returns:
  a new instance of a class that implements `ModelMBean`
Throws:
  `MBeanException` - if creation of the ModelMBean failed

### onRegister

protected void onRegister(ObjectName objectName)
Called when an MBean is registered. Notifies all registered `MBeanExporterListeners` of the registration event.

Please note that if an `MBeanExporterListener` throws a (runtime) exception when notified, this will essentially interrupt the notification process and any remaining listeners that have yet to be notified will not (obviously) receive the `MBeanExporterListener.mbeanRegistered(javax.management.ObjectName)` callback.

Overrides:
  `onRegister` in class `MBeanRegistrationSupport`
Parameters:
  `objectName` - the `ObjectName` of the registered MBean

### onUnregister

protected void onUnregister(ObjectName objectName)
Called when an MBean is unregistered. Notifies all registered `MBeanExporterListeners` of the unregistration event.

Please note that if an `MBeanExporterListener` throws a (runtime) exception when notified, this will essentially interrupt the notification process and any remaining listeners that have yet to be notified will not (obviously) receive the `MBeanExporterListener.mbeanUnregistered(javax.management.ObjectName)` callback.

Overrides:
  `onUnregister` in class `MBeanRegistrationSupport`
Parameters:
  `objectName` - the `ObjectName` of the unregistered MBean